DROP TABLE IF EXISTS SP;
DROP TABLE IF EXISTS P;
DROP TABLE IF EXISTS S;

CREATE TABLE S ( sid CHAR(2), 
                 sname CHAR(20), 
                 status INTEGER, 
                 city CHAR(20), 
                 PRIMARY KEY (sid) ) ENGINE=InnoDB;


CREATE TABLE P ( pid CHAR(2), 
                 pname CHAR(20), 
                 color CHAR(5), 
                 weight INTEGER, 
                 city CHAR(20),
                 PRIMARY KEY (pid) ) ENGINE=InnoDB;


CREATE TABLE SP ( sid CHAR(2), 
                  pid CHAR(2), 
                  qty INTEGER, 
                  PRIMARY KEY (sid, pid), 
                  FOREIGN KEY (sid) REFERENCES S(sid),          
                  FOREIGN KEY (pid) REFERENCES P(pid) ) ENGINE=InnoDB;


INSERT INTO S VALUES( 'S1', 'Smith', 20, 'London' );
INSERT INTO S VALUES( 'S2', 'Jones', 10, 'Paris'  );
INSERT INTO S VALUES( 'S3', 'Blake', 30, 'Paris'  );
INSERT INTO S VALUES( 'S4', 'Clark', 20, 'London' );
INSERT INTO S VALUES( 'S5', 'Adams', 30, 'Athens' );


INSERT INTO P VALUES( 'P1', 'Nut',   'Red',   12, 'London' );
INSERT INTO P VALUES( 'P2', 'Bolt',  'Green', 17, 'Paris'  );
INSERT INTO P VALUES( 'P3', 'Screw', 'Blue',  17, 'Oslo'   );
INSERT INTO P VALUES( 'P4', 'Screw', 'Red',   14, 'London' );
INSERT INTO P VALUES( 'P5', 'Cam',   'Blue',  12, 'Paris'  );
INSERT INTO P VALUES( 'P6', 'Cog',   'Red',   19, 'London' );


INSERT INTO SP VALUES( 'S1', 'P1', 300 );
INSERT INTO SP VALUES( 'S1', 'P2', 200 );
INSERT INTO SP VALUES( 'S1', 'P3', 400 );
INSERT INTO SP VALUES( 'S1', 'P4', 200 );
INSERT INTO SP VALUES( 'S1', 'P5', 100 );
INSERT INTO SP VALUES( 'S1', 'P6', 100 );
INSERT INTO SP VALUES( 'S2', 'P1', 300 );
INSERT INTO SP VALUES( 'S2', 'P2', 400 );
INSERT INTO SP VALUES( 'S3', 'P2', 200 );
INSERT INTO SP VALUES( 'S4', 'P2', 200 );
INSERT INTO SP VALUES( 'S4', 'P4', 300 );
INSERT INTO SP VALUES( 'S4', 'P5', 400 );

-- cause a foreign key error
INSERT INTO SP VALUES( 'S7', 'P5', 400 );

select * from SP;
